- name: Install Dependencies
  become: yes
  ansible.builtin.package:
    name:
      - apt-transport-https
      - ca-certificates
      - curl
      - gnupg
      - lsb-release
    state: present

- name: Check Docker GPG Key
  stat:
    path: /usr/share/keyrings/docker-archive-keyring.gpg
  register: docker_gpg

- name: Add Docker GPG Key
  become: yes
  shell: "curl -fsSL https://download.docker.com/linux/ubuntu/gpg | sudo gpg --dearmor -o /usr/share/keyrings/docker-archive-keyring.gpg"
  args:
    warn: no
  when: not docker_gpg.stat.exists

- name: Add Docker Repository
  become: yes
  ansible.builtin.lineinfile:
    line: "deb [arch=amd64 signed-by=/usr/share/keyrings/docker-archive-keyring.gpg] https://download.docker.com/linux/ubuntu {{ ansible_distribution_release }} stable"
    path: /etc/apt/sources.list.d/docker.list
    create: yes
    owner: root
    group: root

- name: Update and upgrade apt packages
  become: yes
  ansible.builtin.apt:
    upgrade: 'yes'
    update_cache: yes

- name: Install Docker
  become: yes
  ansible.builtin.package:
    name:
      - docker-ce
      - docker-ce-cli
      - containerd.io
    state: present

- name: Ensure Docker Service Enabled
  become: yes
  systemd:
    name: docker
    state: started
    enabled: yes

- name: Add user to docker group
  become: yes
  user:
    name: "{{ lookup('env', 'USER') }}"
    groups: docker
    append: yes

